/**
 * 
 */
package edu.nyu.scps.date;

/**
 * @author nyuuser
 *
 */
public class SmarterDate extends edu.nyu.scps.date.Date {
	/**
	 * The length of the current month.
	 * Smart enough to know about leap years.
	 * 
	 * @return number of days in month to which this Date object belongs
	 */
	@Override
	protected int length() {
		if (month != 2) {
			return super.length();
		}
		
		boolean isLeap;	//warning: born containing garbage.
		
		//Steer the computer in one of four possible directions.
		if (year % 400 == 0) {
			isLeap = true;
		} else if (year % 100 == 0) {
			isLeap = false;
		} else if (year % 4 == 0) {
			isLeap = true;
		} else {
			isLeap = false;
		}
		
		//Steer the computer in one of two possible directions.
		if (isLeap) {
			return 29;
		} else {
			return 28;
		}
	}
	
	/**
	 * @param month
	 * @param day
	 * @param year
	 */
	public SmarterDate(int month, int day, int year) {
		super(month, day, year);
	}
}
